//*****************************************************************************************************
//  1. t@C
//		ArrayEx.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CStringArrayEx, CIntArrayEx NX̃Cve[V
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "workscheduler.h"
#include "ArrayEx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//*****************************************************************************************************
//  1. ֐
//		CStringArrayEx::Unique
//----------------------------------------------------------------------------------------------------
//  2. @\
//		z̏d폜ăj[N
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		z񂩂dĂ镶폜B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CStringArrayEx::Unique()
{
	CMapStringToPtr cMap;
	void *pDummy;

	for (int i = 0; i < GetSize(); ) {
		if (cMap.Lookup(ElementAt(i), pDummy))
			RemoveAt(i);
		else {
			cMap.SetAt(ElementAt(i), NULL);
			i++;
		}
	}
}

int CStringArrayEx::Find(LPCTSTR pStr)
{
	int nSize = GetSize();
	for (int i = 0; i < nSize; i++) {
		if (ElementAt(i) == pStr)
			return i;
	}

	return -1;
}

int CStringArrayEx::AddUnique(LPCTSTR pStr)
{
	int nIndex;

	if ((nIndex = Find(pStr)) == -1)
		nIndex = Add(pStr);

	return nIndex;
}

// 
CString CStringArrayEx::Join(LPCTSTR pDelimiter)
{
	CString sString;

	int nSize = GetSize();
	for (int i = 0; i < nSize; i++) {
		if (i != 0)
			sString += pDelimiter;
		sString += ElementAt(i);
	}

	return sString;
}

// 𕪊
void CStringArrayEx::Split(LPCTSTR pDelimiter, const CString &sText)
{
	int nLen = strlen(pDelimiter);
	int nPos1 = 0;
	int nPos2;

	RemoveAll();
	while (true) {
		nPos2 = sText.Find(pDelimiter, nPos1);
		if (nPos2 != -1) {
			Add(sText.Mid(nPos1, nPos2 - nPos1));
			nPos1 = nPos2 + nLen;
		} else {
			Add(sText.Mid(nPos1));
			break;
		}
	}
}

void CIntArrayEx::Unique()
{
	CMapPtrToPtr cMap;
	void *pDummy;

	for (int i = 0; i < GetSize(); ) {
		if (cMap.Lookup((void *)ElementAt(i), pDummy))
			RemoveAt(i);
		else {
			cMap.SetAt((void *)ElementAt(i), NULL);
			i++;
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CIntArrayEx::Sort
//----------------------------------------------------------------------------------------------------
//  2. @\
//		z\[g
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		z̗vfɃ\[gB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CIntArrayEx::Sort()
{
	qsort(GetData(), GetSize(), sizeof(UINT), CompareSort);
}

//*****************************************************************************************************
//  1. ֐
//		CIntArrayEx::Find
//----------------------------------------------------------------------------------------------------
//  2. @\
//		z񌟍
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		n		[I] f[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int			vf̃CfbNXiȂꍇ-1j
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		z񂩂w肳ꂽf[^Avf̃CfbNXԂB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
int CIntArrayEx::Find(int n)
{
	int nSize = GetSize();
	for (int i = 0; i < nSize; i++) {
		if (ElementAt(i) == n)
			return i;
	}

	return -1;
}

//*****************************************************************************************************
//  1. ֐
//		CIntArrayEx::AddUnique
//----------------------------------------------------------------------------------------------------
//  2. @\
//		j[NȒlzɒǉ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		n		[I] ǉf[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUEFǉ
//					FALSEFɓf[^̂ŒǉȂ
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		zɎw肳ꂽf[^邩A΂̃f[^ǉB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
int CIntArrayEx::AddUnique(int n)
{
	int nIndex;

	if ((nIndex = Find(n)) == -1)
		nIndex = Add(n);

	return nIndex;
}

//*****************************************************************************************************
//  1. ֐
//		CIntArrayEx::AddUnique
//----------------------------------------------------------------------------------------------------
//  2. @\
//		zf[^r
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		void		*arg1		[I] rf[^
//		void		*arg2		[I] r̃f[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int			r
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		zɎw肳ꂽf[^邩A΂̃f[^ǉB
//----------------------------------------------------------------------------------------------------
//  6. l
//		qsort()R[obNB
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
int CIntArrayEx::CompareSort(const void *arg1, const void *arg2)
{
	return *(int *)arg1 - *(int *)arg2;
}
